/*Semnale--program care din 3 in 3 secunde scrie un numar aleatoriu intr-un fisier */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <fcntl.h>

#define FILENAME "alarm" /*numele fisierului*/
#define TIMER 3 /* temporizare la 3 secunde */

int status;

static void
scrie()       /* scrie numarul in fisier */
{
  FILE * f;
  f = fopen (FILENAME, "+a") ;
  if (f== NULL)
    {
      perror ("Nu pot deschide fisierul! Folosesc stdout...\n");
      printf("%d\n", rand() % 1000);
    } else {
      fprintf(f, "%d\n", rand() % 1000);
      fclose(f);
    }
}

void alarma()   /* trateaza SIGALRM */
{
  //la aparitia lui SIGALRM va fi apelata scrie()
  if (signal (SIGALRM, scrie)== SIG_ERR)
    {
      perror("signal()");
      exit(1);
    }
   while (1)      /* rulam la infinit... */
   {
     alarm(TIMER); /* setam o alta alarma */
     pause();   /* asteptam aparitia unui ALT semnal */
   }
}

int main (void)  /*programul principal */
{
  int fd ;
  fd = open (FILENAME, O_CREAT | O_TRUNC | O_WRONLY, 0666) ;
  close (fd) ;
  switch(fork())
   {
     case -1:
          perror("fork()");  /* lansam procesul in fundal */
          return -1;
     case 0:               /* copilul preia executia */
          alarma();
     default:            /* parintele se termina */
          sleep(1);
	  wait (&status) ;
	  return status ;
    }
}
