#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

volatile sig_atomic_t usr1=0, usr2=0, hup=0 ;

void catcher (int signo)
{
   if (signo == SIGUSR1) usr1++ ;
   if (signo == SIGUSR2) usr2++ ;
   if (signo == SIGHUP)  hup++ ;
   if (usr1 == 1 || usr2 == 1) 
     kill (-getpid(), signo) ;
   printf ("Signal %d occured\n", signo) ;
}

int child_one () 
{
   sigset_t block_set ;
   sigfillset (&block_set) ;
   sigdelset (&block_set, SIGUSR1) ;
   sigprocmask (SIG_BLOCK, &block_set, NULL) ;
   while (!usr1) 
     {
	sleep (1) ;
     }
   printf ("Child %d terminated due to SIGUSR1\n", getpid()) ;
   return EXIT_SUCCESS ;
}


int child_two () 
{
   sigset_t block_set ;
   sigfillset (&block_set) ;
   sigdelset (&block_set, SIGUSR2) ;
   sigprocmask (SIG_BLOCK, &block_set, NULL) ;
   while (!usr2) 
     {
	sleep (1) ;
     }
   printf ("Child %d terminated due to SIGUSR2\n", getpid()) ;
   return EXIT_SUCCESS ;
}


int main () 
{
   int status ;
   sigset_t block_set ;
   sigfillset (&block_set) ;
   sigdelset (&block_set, SIGHUP) ;
   sigdelset (&block_set, SIGUSR1) ;
   sigdelset (&block_set, SIGUSR2) ;

   signal (SIGUSR1, catcher) ;
   signal (SIGUSR2, catcher) ;
   signal (SIGHUP, catcher) ;
   signal (SIGCLD, SIG_IGN) ;
   
   if (fork () == 0) 
     {
	return child_one () ;	
     }
   if (fork () == 0) 
     {
	return child_two () ;
     }   
   sigprocmask (SIG_BLOCK, &block_set, NULL) ;
   while (!hup) 
     {
	if (sleep (100) == -1)  /* JUST WAIT */
	  {
	     printf ("Signal occured...\n") ;
	  }
	
     }
   printf ("Parent %d terminated due to SIGHUP\n", getpid()) ;
   printf ("Waiting for childs ...\n") ;
   printf ("Sending USR1 for remaining childs...\n") ;
   kill (-getpid(), SIGUSR1) ;
   wait (&status) ;
   printf ("Sending USR2 for remaining childs...\n") ;
   kill (-getpid(), SIGUSR2) ;
   wait (&status) ;
   printf ("Childs terminated\n") ;
   
   return EXIT_SUCCESS ;
}
