#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>

volatile sig_atomic_t childs = 0 ;

int show_status (int pid, int status) 
{
   printf ("[Process %d ended ", pid) ;
   if (WIFEXITED(status)) {
      if (WEXITSTATUS(status) == 0) printf ("normally ") ;
      printf ("with value %d]\n", WEXITSTATUS(status)) ;
   }
   if (WIFSIGNALED(status)) {
      printf ("due to an unhandled signal with value %d]\n",
	      WTERMSIG(status)) ;
   }
   if (WCOREDUMP(status)) {
      printf ("Look for a coredump for process %d:)\n", pid) ;
   }
   if (WIFSTOPPED(status)) {
      printf ("Process %d was stopped due to a %d signal\n", pid,
	      WSTOPSIG(status)) ;
   }
   
   return 0 ;
}


void chld_catch (int signo) 
{
   int saferrno, pid, status ;
   saferrno = errno ;
   while (1 && childs) 
     {
	pid = waitpid (WAIT_ANY, &status, WNOHANG) ;
	if (pid < 0) 
	  {
	     perror ("on waitpid") ; break ;	    
	  }
	if (pid == 0) break ;
	childs -- ;
	show_status (pid, status) ;	
     }   
}

int main () 
{
   int i = 0; 
   signal (SIGCLD, chld_catch) ;
   for (i = 0; i < 10; i++)
     {
	     childs ++ ;
	if (fork () == 0) 
	  {
	     sleep ((i+1) * 5) ;
	     exit (0) ;
	  }
     }
   for (;;) {
      printf ("In FOR %d\n", childs) ;
      sleep (3) ;
   };
   return 0 ;
}
