#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <signal.h>

void naive (int signo) 
{
   printf ("Signal %d occured\n", signo) ;
   return ;
}


int main () 
{
   sigset_t amask, wmask, anymask ;

   signal (SIGINT, naive) ;
   signal (SIGTSTP, naive) ;
   signal (SIGUSR1, naive) ;
   
   sigemptyset (&amask) ;
   sigaddset (&amask, SIGINT) ;
   sigaddset (&amask, SIGTSTP) ;
   sigaddset (&amask, SIGUSR1) ;

   sigprocmask (SIG_BLOCK, &amask, &wmask) ;
   
   for (;;) 
     {
	// Wait for BLOCKED SIGNALS ...
	puts ("wait for signal") ;
	sigsuspend(&wmask) ;
	puts ("continue") ;
	if (sigismember (&wmask, SIGINT) ||
	    sigismember (&wmask, SIGTSTP)) 
	  {
	     printf ("Wait 10 more seconds before react...\n") ;
	     sleep (10) ;
	     raise (SIGHUP) ;
	  }
     }
   return 0 ;
}
